﻿//Copyright (C) 2007 Christian Scheller

using System;
using System.Collections.Generic;
using System.Text;
using AspectTypes;

namespace ApplicationModel {

    public class Task {
        public Identifier ID = new Identifier("TaskIDSequence", 10000, 1000);
        public Description Text = new Description();
        public DueDate Reminder = new DueDate(15);
        public DueDate Deadline = new DueDate(20);
        public Notification Notify = new Notification();

        public Task() {
            Deadline.Due += Notify.Notify;
            Deadline.Completed += Reminder.Cancel;
            Reminder.Due += Notify.Notify;
            Notify.Message += delegate {
                if (Deadline.State == DueDate.States.Due) {
                    return Text.Value + " is due";
                } else {
                    return Text.Value + " will be due on " + Deadline.Date.ToShortDateString();
                }
            };
        }

        public override string ToString() {
            return Text.Value;
        }
    }
}