<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="text"/>
  <xsl:template match ="Class" xml:space ="preserve">
  public class <xsl:value-of select="@name"/>Facade {
  public static List&lt;<xsl:value-of select="@name"/>&gt; GetAll(SqlConnection connection) {
      List&lt;<xsl:value-of select="@name"/>&gt; result = new List&lt;<xsl:value-of select="@name"/>&gt;();
        SqlCommand command = connection.CreateCommand();
        command.CommandText = @"select 
        <xsl:for-each select="Aspects/*">
          <xsl:choose>
            <xsl:when test ="name() = 'DueDate'">
              <xsl:value-of select="@name"/>Date,
              <xsl:value-of select ="@name"/>State
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select ="@name"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test="position() != last()">,</xsl:if>
        </xsl:for-each>
        from <xsl:value-of select="@name"/>";
        using (SqlDataReader reader = command.ExecuteReader()) {
        while (reader.Read()) {
        <xsl:value-of select="@name"/> item = new <xsl:value-of select="@name"/>();
        <xsl:for-each select="Aspects/*">
        <xsl:choose >
          <xsl:when test="name() = 'DueDate'">
            item.<xsl:value-of select ="@name"/>.Date = (DateTime) reader["<xsl:value-of select ="@name"/>Date"];
            item.<xsl:value-of select ="@name"/>.State = (DueDate.States) reader["<xsl:value-of select ="@name"/>State"];
          </xsl:when>
          <xsl:when test="name() = 'Identifier'">
            item.<xsl:value-of select ="@name"/>.Value = (int) reader["<xsl:value-of select ="@name"/>"];
          </xsl:when>
          <xsl:when test ="name() = 'Notification'">
            item.<xsl:value-of select ="@name"/>.EMailAddress = (string) reader["<xsl:value-of select ="@name"/>"];            
          </xsl:when>
          <xsl:otherwise>
            item.<xsl:value-of select ="@name"/>.Value = (string) reader["<xsl:value-of select ="@name"/>"];
          </xsl:otherwise>
        </xsl:choose>
          </xsl:for-each>
        result.Add(item);
        }
        }
        return result;
        }

        public static void Insert(<xsl:value-of select ="@name"/> item, SqlConnection connection) {
        SqlCommand command = connection.CreateCommand();
        command.CommandText = @"insert into <xsl:value-of select ="@name"/> (
        <xsl:for-each select="Aspects/*">
          <xsl:choose >
            <xsl:when test="name() = 'DueDate'">
              <xsl:value-of select ="@name"/>Date,
              <xsl:value-of select ="@name"/>State
            </xsl:when>
            <xsl:otherwise >
              <xsl:value-of select ="@name"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test ="position() != last()">,</xsl:if>
        </xsl:for-each>
        ) values (
        <xsl:for-each select="Aspects/*">
          <xsl:choose >
            <xsl:when test="name() = 'DueDate'">
              @<xsl:value-of select ="@name"/>Date,
              @<xsl:value-of select ="@name"/>State
            </xsl:when>
            <xsl:otherwise >
              @<xsl:value-of select ="@name"/>
            </xsl:otherwise>
          </xsl:choose>
          <xsl:if test ="position() != last()">,</xsl:if>
        </xsl:for-each>
        )";
        <xsl:for-each select ="Aspects/*">
          <xsl:choose >
            <xsl:when test="name() = 'DueDate'">
        command.Parameters.AddWithValue("@<xsl:value-of select ="@name"/>date",item.<xsl:value-of select ="@name"/>.Date);
        command.Parameters.AddWithValue("@<xsl:value-of select ="@name"/>state", item.<xsl:value-of select ="@name"/>.State);              
            </xsl:when>
            <xsl:when test="name() = 'Notification'">
        command.Parameters.AddWithValue("@<xsl:value-of select ="@name"/>", item.<xsl:value-of select ="@name"/>.EMailAddress);                            
            </xsl:when>
            <xsl:otherwise>
        command.Parameters.AddWithValue("@<xsl:value-of select ="@name"/>", item.<xsl:value-of select ="@name"/>.Value);              
              
            </xsl:otherwise>
          </xsl:choose>
        </xsl:for-each>
        command.ExecuteNonQuery();
        }
        }
        </xsl:template>
</xsl:stylesheet>