﻿//Copyright (C) 2007 Christian Scheller

using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace AspectTypes {
    public class DueDate {
        public enum States { Active, Due, Completed, Canceled }
        public DateTime Date;
        public States State = States.Active;
        public event EventHandler Due;
        public event EventHandler Completed;
        public event EventHandler Canceled;

        private static List<DueDate> DueDates = new List<DueDate>();

        public DueDate(int days) {
            Date = DateTime.Now.AddDays(days);
            DueDates.Add(this);
        }

        public static void Check(DateTime date) {
            foreach (DueDate dueDate in DueDates) {
                if (dueDate.Date < date && dueDate.State == States.Active) {
                    dueDate.State = States.Due;
                    if (dueDate.Due != null) {
                        dueDate.Due(dueDate, null);
                    }
                }
            }
        }

        public void Complete(object sender, EventArgs e) {
            State = States.Completed;
            if (Completed != null) {
                Completed(this, null);
            }
        }

        public void Cancel(object sender, EventArgs e) {
            if (State == States.Active) {
                State = States.Canceled;
                if (Canceled != null) {
                    Canceled(this, null);
                }
            }
        }
    }
}
